/**
	@ author A.Matsuo and K.Shimbuchi
	@ since 1.4.2
	@ Ί@ʍœK𐶐vO
*/

import java.math.BigInteger;
import java.awt.geom.*;
import java.awt.Point;
import java.awt.Frame;
import java.awt.FileDialog;
import java.io.File;
import java.io.IOException;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.StringTokenizer;
import java.util.Arrays;

public class MasLauncher extends Frame{

	private int[] a;
	private BigInteger numLeft;
	private BigInteger total;

	public MasLauncher (int n) {
		if (n < 1) {
			throw new IllegalArgumentException ("Min 1");
		}
		a = new int[n];
		total = getFactorial (n);
		reset ();
	}

	public void reset () {
		for (int i = 0; i < a.length; i++) {
			a[i] = i;
		}
		numLeft = new BigInteger (total.toString ());
	}

	public BigInteger getNumLeft () {
		return numLeft;
	}

	public BigInteger getTotal () {
		return total;
	}

	public boolean hasMore () {
		return numLeft.compareTo (BigInteger.ZERO) == 1;
	}

	private static BigInteger getFactorial (int n) {
		BigInteger fact = BigInteger.ONE;
		for (int i = n; i > 1; i--) {
			fact = fact.multiply (new BigInteger (Integer.toString (i)));
		}
		return fact;
	}

	public int[] getNext () {

		if (numLeft.equals (total)) {
			numLeft = numLeft.subtract (BigInteger.ONE);
			return a;
		}
		int temp;
		int j = a.length - 2;
		while (a[j] > a[j+1]) {
			j--;
		}
		int k = a.length - 1;
		while (a[j] > a[k]) {
			k--;
		}
		temp = a[k];
		a[k] = a[j];
		a[j] = temp;

		int r = a.length - 1;
		int s = j + 1;

		while (r > s) {
			temp = a[s];
			a[s] = a[r];
			a[r] = temp;
			r--;
			s++;
		}
		numLeft = numLeft.subtract (BigInteger.ONE);
		return a;
	}

	public MasLauncher(){

		String absFileName;
		FileDialog fileDialog = new java.awt.FileDialog(this);
		fileDialog.setMode(FileDialog.LOAD);
		fileDialog.setTitle("Choose the absFile to use:");
		fileDialog.setVisible(true);

	   //_CAOpX擾AmF
		String resultPath = fileDialog.getDirectory();
		String resultFile = fileDialog.getFile();

		if(resultPath != null && resultPath.length()!= 0 &&
		   resultFile != null && resultFile.length() != 0)
		{
			File file = new File(resultPath + resultFile);
			if(file != null)
			{
				absFileName = file.getPath();

			try
				 {
					 //Ԗڂ̈ɁAMAS.exëʒuw肵ĂBꏊقȂꍇ͕ύXĂ
					Runtime.getRuntime().exec(new String[] {"C:/Program Files/Multi Agent Simulator/MAS.exe", absFileName});
				}
				catch (IOException exc)
				{
					exc.printStackTrace();
				}
			}
		}
    }

    public MasLauncher(String absFileName){

		try
			 {
				 //Ԗڂ̈ɁAMAS.exëʒuw肵ĂBꏊقȂꍇ͕ύXĂ
				Runtime.getRuntime().exec(new String[] {"C:/Program Files/Multi Agent Simulator/MAS.exe", absFileName});
			}
			catch (IOException exc)
			{
				exc.printStackTrace();
			}

    }

	public static void main(String[] args)
	{

		int flag = -1;
		int flag2 = -1;

		ShowWindow swn = new ShowWindow("œKΊvZAv");
		while (swn.getFlag2() == -1)
		{
			try {
				Thread.sleep(1000);
			} catch(Exception e) {}
		}
		//swn.dispose();
		flag2 = swn.getFlag2();

		if (flag2 == 1){
			//΍Дʒu
			//wW
			WriteCSV wcsvFireX = new WriteCSV(",","FirstFireX.txt");
			wcsvFireX.makeCsvFile();
			//xW
			WriteCSV wcsvFireY = new WriteCSV(",","FirstFireY.txt");
			wcsvFireY.makeCsvFile();
			//ĔQ\l
			WriteCSV wcsvSpreadFire = new WriteCSV(",","SpreadFire.txt");
			wcsvSpreadFire.makeCsvFile();

			//MASNA΍ДzuAĔQ\l߂
			new MasLauncher();
		}

		while (swn.getFlag() == -1)
		{
			try {
				Thread.sleep(1000);
			} catch(Exception e) {}
		}

		flag = swn.getFlag();//Ί@Qbg
		swn.dispose();

		ReadCSV rcsvFileX = new ReadCSV("FirstFireX.txt");
		int numberFire = rcsvFileX.countFire();	//΍Д擾
		String[] fireX = rcsvFileX.readCsvFile();	//wW擾
		String fireMasX = "/";	//l`rpWf[^
		for(int i = 0; i < numberFire; i ++){
			fireMasX += fireX[i] + "/";
		}

		ReadCSV rcsvFileY = new ReadCSV("FirstFireY.txt");
		String[] fireY = rcsvFileY.readCsvFile();	//YW擾
		String fireMasY = "/";
		for(int i = 0; i < numberFire; i ++){
			fireMasY += fireY[i] + "/";
		}

		//΍Јʒu|Cg^ϐɁAi[
		Point[] firePoint = new Point[numberFire];
		for(int i = 0; i <numberFire; i++){
			firePoint[i] = new Point(Integer.parseInt(fireX[i]),Integer.parseInt(fireY[i]));
		}

		//Masǂݍ݂悤Wf[^
		WriteCSV wcsvFireX2 = new WriteCSV(fireMasX,"FirstFireX2.txt");
		wcsvFireX2.makeCsvFile();
		WriteCSV wcsvFireY2 = new WriteCSV(fireMasY,"FirstFireY2.txt");
		wcsvFireY2.makeCsvFile();

		//ĔQ\lAspreadfirezɊi[
		int spreadfire[][] = new int[numberFire][numberFire];
		ReadCSV rcsvFile2 = new ReadCSV("SpreadFire.txt");
		String[] sFire = rcsvFile2.readCsvFile();	//YW擾
		for(int i = 0; i < numberFire; i ++){
				spreadfire[i][0] = Integer.parseInt(sFire[i]) * (-1);
				spreadfire[i][1] = (int)(Integer.parseInt(sFire[i]) * (-0.5));
				System.out.println(spreadfire[i][0]);
				System.out.println(spreadfire[i][1]);
		}

		// hz
		Point[] fighterPoint = new Point[3];

		int k = 1;
		int m = 0;
		int n = 0;

		//Dxp[^
		double pm = 0.25;
		if(flag == 1){
			//[UɁAĒnDxq˂
			ShowWindow2 myShowWindow2 = new ShowWindow2("ĒnDx");
			while (myShowWindow2.getNumber() == -1)
					{
						try {
							Thread.sleep(1000);
						} catch(Exception e) {}
			}
			pm = myShowWindow2.getNumber();
			myShowWindow2.dispose();
		}

		//]֐G̒lŏ
		double ffa = 1000;
		double ffb = 1000;

		int[] indices;
		Point2D point = new Point2D.Double();

		//ׂĂ̑gݍ킹vZ邽߂́Az𐶐
		int[] elements = new int[numberFire+2];
		for (int i = 0; i < numberFire; i++){
			elements[i] = i;
		}
		elements[numberFire] = -1;
		elements[numberFire + 1] = -1;

		//œḰA̔zɊi[
		int[] elements2 = new int[numberFire+2];

		MasLauncher x = new MasLauncher(elements.length);

		//ŋ߉΍ЗDΊ@
		if (flag == 2){
			//̏ḧʒu
			fighterPoint[0] = new Point(49,25);
			fighterPoint[1] = new Point(24,75);
			fighterPoint[2] = new Point(75,75);

			elements2 = new int[numberFire*3+2];
			int[][] quota = new int[numberFire][3];

			int intA = 0;

			for(int i  = 0; i < 3;i++){
				double[] nowDistance = new double[3];
				double[] minDistance = {200,200,200};

				Point[] firePoint2 = new Point[numberFire];
				for(int s = 0; s <numberFire; s++){
						firePoint2[s] = new Point(Integer.parseInt(fireX[s]),Integer.parseInt(fireY[s]));
				}

				for(int r = 0; r < numberFire; r++){
					nowDistance = new double[3];
					minDistance[i] = 200;

					for(int j = 0;j < numberFire; j++){
						//fighterPoint[i]ԋ߂΍ЂT
						nowDistance[i] = fighterPoint[i].distance(firePoint2[j]);
						//܂łňԒẐƂAminDistance[i]XV
						if(nowDistance[i] < minDistance[i]){
							minDistance[i] = nowDistance[i];
							intA = j;
						}
					}
					//ɒǉAfighterPoint[i]΍Ђ̈ʒuɕύX
					quota[r][i] = intA;
					fighterPoint[i] = firePoint2[intA];
					//xI΍ЂĂёIȂ悤ɉʒuɂ
					firePoint2[intA] = new Point(1000,1000);
					if(i == 0){
						elements2[r] = intA;
					}
					else{
						elements2[r+(i*numberFire)+1] = intA;
					}
					System.out.print(quota[r][i] + "/");
				}
				elements2[numberFire*(i+1)] = -1;
				System.out.println(-1);
			}
		}

		else{
			String str = null;
			long startTime = System.currentTimeMillis();	// whileJn

			//whileׂ͂Ă̑gݍ킹I܂Ŏs
			while (x.hasMore ()) {
				double fnumber[][] = new double[3][2];

				double fy = 0;
				double fz = 0;

				//̏ḧʒu
				fighterPoint[0] = new Point(49,25);
				fighterPoint[1] = new Point(24,75);
				fighterPoint[2] = new Point(75,75);

				indices = x.getNext ();

				// -1ŏ@-1͊蓖ĂȂƂ킷

				for(int i = 0;i < indices.length; i++){
					int j = elements[indices[i]];
					if(j == -1){
						m = i+1;		// "/"̂ꏊ̎m
						break;
					}
					else{
						//a̐ɉ΍Ђ̗DʂƋ̑a
						fnumber[0][0] += firePoint[j].distance(fighterPoint[0]);
						fnumber[0][1] += spreadfire[j][i];
						fighterPoint[0].setLocation(firePoint[j]);
					}
				}
				for(int i = m;i < indices.length; i++){
					int j = elements[indices[i]];
					if(j == -1){
						n = i+1;
						break;
					}
					else{
						fnumber[1][0] += firePoint[j].distance(fighterPoint[1]);
						fnumber[1][1] += spreadfire[j][i-m];
						fighterPoint[1].setLocation(firePoint[j]);
					}
				}
				for(int i = n;i < indices.length; i++){
					int j = elements[indices[i]];
					if(j == -1){
						break;
					}
					else{
						fnumber[2][0] += firePoint[j].distance(fighterPoint[2]);
						fnumber[2][1] += spreadfire[j][i-n];
						fighterPoint[2].setLocation(firePoint[j]);
					}
				}

				//ĔQ\lfyɁȂafzɊi[
				fy = (fnumber[0][1] + fnumber[1][1]  + fnumber[2][1]);
				fz = fnumber[0][0] + fnumber[1][0]  + fnumber[2][0];

				//ŏΊ@
				if (flag == 0){
					if(ffb>fz){
						ffb = fz;
						System.out.print("݂̍œK : ");
						for (int i = 0; i < indices.length; i++){
								if(elements[indices[i]] == -1){
									System.out.print("/");
								}
								else{
									System.out.print(elements[indices[i]]);
								}
								elements2[i] = elements[indices[i]];
						}
						System.out.println("\t"+ "]֐lF"+ (int)(ffb)+ "\n"+ fnumber[0][0]+"\t" +fnumber[1][0] + "\t" + fnumber[2][0]);
					}
				}
				//ĒnDΊ@
				else if (flag == 1){
					if(ffa>(1-pm)*fz+pm*fy){
						ffa = (1-pm)*fz + pm*fy;
						System.out.print("݂̍œK : ");
						for (int i = 0; i < indices.length; i++){
							if(elements[indices[i]] == -1){
								System.out.print("/");
							}
							else{
								System.out.print(elements[indices[i]]);
							}
							elements2[i] = elements[indices[i]];
						}
						System.out.println("\t" + k + "\t]֐lF" + (int)(ffa) + "\n"+ fnumber[0][0]+"\t" +fnumber[1][0] + "\t" + fnumber[2][0]);
					}
				}
			k++;
			}//whileI

		long endTime = System.currentTimeMillis();	// whileI

		System.out.println("Dx"+ pm + "łB");
		System.out.println("vZɂ " + (endTime - startTime)/60000 + "minites");
		System.out.println("œKF");

	}

	String text = "/";
	StringBuffer sbuf = new StringBuffer(text);
	//"-1"ŋ؂ꂽAf[^"-1""/"ɕϊAelements2Ɋi[
	for (int i = 0; i < elements2.length; i++){
		if(elements2[i] == -1){
			m = i + 1;
			break;
		}
		else{
			sbuf.append(elements2[i]);
		}
		text += elements2[i] + "/";
	}

	//text = sbuf.toString();
	System.out.println("hP̏ΊF" + text);
	//hP̊f[^o
	WriteCSV wcsv1 = new WriteCSV(text, "text1.txt");

	wcsv1.makeCsvFile();

	String text2 = "/";
	StringBuffer sbuf2 = new StringBuffer(text2);
	for (int i = m; i < elements2.length; i++){
		if(elements2[i] == -1){
			n = i + 1;
			break;
		}
		else{
			sbuf2.append(elements2[i]);
		}
		text2 +=elements2[i] + "/";
	}
//	text2 = sbuf2.toString();
	System.out.println("hQ̏ΊF" + text2);
	//h2̊f[^o
	WriteCSV wcsv2 = new WriteCSV(text2, "text2.txt");
	wcsv2.makeCsvFile();

	String text3 = "/";
	StringBuffer sbuf3 = new StringBuffer(text3);
		for (int i = n; i < elements2.length; i++){
			if(elements2[i] == -1){
				break;
			}
			else{
				sbuf3.append(elements2[i]);
			}
			text3 += elements2[i] + "/";
		}
	//text3 = sbuf3.toString();
	System.out.println("hȐΊF" + text3);
	//h3̊f[^o
	WriteCSV wcsv3 = new WriteCSV(text3, "text3.txt");
	wcsv3.makeCsvFile();
	/* "΍ЃV~[^.abs"̊i[ʒuL΁AIȂĂ
	new MasLauncher("c:\\Documents and Settings\\Keisuke\\My Documents\\Ƙ_\\JavaMas\\΍ЃV~[^.abs");
    */
    new MasLauncher();
    System.exit(0);
	}
}

//bruǂݍ݃NX
class ReadCSV {

	String csvName;

 	public ReadCSV(String textName){
			csvName = textName;
	}

	//΍Д擾\bh
	public int countFire(){
		int numberFire = 0;
		try {
			File csv = new File("NumberFire.txt");
			BufferedReader br = new BufferedReader(new FileReader(csv));
			while (br.ready()) {
				String line = br.readLine();
				StringTokenizer st = new StringTokenizer(line, ",");
				while (st.hasMoreTokens()) {
					numberFire = Integer.parseInt(st.nextToken());
				}
			}
			br.close();
			//΍ЌԂ
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return numberFire;
	}

 	public String[] readCsvFile() {

		String[] csvData = new String[countFire()*2];
		int i = 0;

		try {
			File csv = new File(csvName); // CSVf[^t@C

			BufferedReader br = new BufferedReader(new FileReader(csv));
			// ŏIs܂œǂݍ
			while (br.ready()) {
				String line = br.readLine();
				// 1sf[^̗vfɕ
				StringTokenizer st = new StringTokenizer(line, ",");
				while (st.hasMoreTokens()) {
					// 1s̊evf^u؂ŕ\
					//System.out.print(st.nextToken() + "\t");
					csvData[i] = st.nextToken();
					i ++;
				}
			//System.out.println();
			}

			br.close();

		} catch (FileNotFoundException e) {
			// FileIuWFNg̗Oߑ
			e.printStackTrace();
		} catch (IOException e) {
			// BufferedReaderIuWFNg̃N[Y̗Oߑ
			e.printStackTrace();
		}
		return csvData;
  }
}

//CSVt@Co̓NX
class WriteCSV {

	String csvText;
	String csvName;

	public WriteCSV(String text, String textName){
		csvText = text;
		csvName = textName;
	}

	public void makeCsvFile(){
		try {
				File csv = new File(csvName); // CSVf[^t@C
				BufferedWriter bw = new BufferedWriter(new FileWriter(csv, false));
				// Vȃf[^s̒ǉ
				bw.write(csvText);
				//bw.newLine();
				bw.close();

			} catch (FileNotFoundException e) {
				// FileIuWFNg̗Oߑ
				e.printStackTrace();
			} catch (IOException e) {
				// BufferedWriterIuWFNg̃N[Y̗Oߑ
				e.printStackTrace();
			}
	}

}

class ShowWindow extends JFrame {

	int flag1 = -1;
	int flag2 = -1;

	public ShowWindow(String title) {
		super(title);
		final JButton myBtn3 = new JButton("΍ЂVɐȂ");
		final JButton myBtn2 = new JButton("΍ЂVɐ");
		final JButton myBtn1 = new JButton("ŋ߉΍ЗDΊ@");
		final JButton myBtn = new JButton("ŏΊ@");
		final JButton myClrBtn = new JButton("ĒnDΊ@");
		final JTextArea myText = new JTextArea();
		myText.setLineWrap(true);
		myText.setBackground(Color.white);
		JScrollPane myScroll = new JScrollPane(myText);
		myText.setText("΍ЂV邩IĂB");

		myBtn3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				flag2 = 2;
				myText.setText("΍ЂVɐ܂BΊ@IłB");

			}
		});

		myBtn2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				flag2 = 1;
				myText.setText("l`rN΍Ђ𐶐܂BV~[VIAΊIłB");

			}
		});

		myBtn1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				flag1 = 2;
				myText.setText("ŋ߉΍ЗDΊ@I܂BœK߁Al`rN܂B");

			}
		});

		myBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				flag1 = 0;
				myText.setText("ŏΊ@I܂BœK߁Al`rN܂B");
			}
		});

		myClrBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				flag1 = 1;
				myText.setText("ĒnDΊ@I܂BœK߁Al`rN܂B");
			}
		});

		//pl쐬ă{^ڂ
		JPanel myPanel = new JPanel();
		myPanel.setLayout(new GridLayout(1, 2));
		myPanel.add(myBtn2);
		myPanel.add(myBtn3);
		JPanel myPanel2 = new JPanel();
		myPanel2.setLayout(new GridLayout(1, 3));
		myPanel2.add(myBtn1);
		myPanel2.add(myBtn);
		myPanel2.add(myClrBtn);

		//PanelLabelt[ɍڂ
		this.getContentPane().add(myPanel, BorderLayout.NORTH);
		this.getContentPane().add(myPanel2, BorderLayout.CENTER);
		this.getContentPane().add(myScroll, BorderLayout.SOUTH);

		//t[iEBhEjۂ̏`
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});

		//Look & Feel̐ݒ
		try {
			//MotifX^CLook&Feelɐݒ
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");

			// ݒ𔽉f
			SwingUtilities.updateComponentTreeUI(this);

		//G[ubN
		} catch (Exception e) {
		}

		//t[̃TCY`ĕ\
		this.setSize(700, 130);
		this.setVisible(true);
	}

	public int getFlag(){
		return flag1;
	}
	public int getFlag2(){
		return flag2;
	}
}

class ShowWindow2 extends JFrame {

	double number = -1;

	public ShowWindow2(String title) {
		super(title);

		final JTextArea myText = new JTextArea("25",1,3);
		//myText.setLineWrap(true);
		myText.setBackground(Color.white);
		final JButton myButton = new JButton("");
		final JLabel myLabel = new JLabel("ĒnD抄");
		final JLabel myLabel2 = new JLabel("(%)");


		//pl쐬ă{^ڂ
		JPanel myPanel = new JPanel();
		myPanel.add(myLabel);
		myPanel.add(myText);
		myPanel.add(myLabel2);
		myPanel.add(myButton);

		//PanelLabelt[ɍڂ
		this.getContentPane().add(myPanel, BorderLayout.NORTH);
		//this.getContentPane().add(myLabel, BorderLayout.CENTER);

		myButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				number = Double.parseDouble(myText.getText());
				number = number/100;
			}
		});

		//t[iEBhEjۂ̏`
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});

		//Look & Feel̐ݒ
		try {
			//MotifX^CLook&Feelɐݒ
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");

			// ݒ𔽉f
			SwingUtilities.updateComponentTreeUI(this);

		//G[ubN
		} catch (Exception e) {
		}

		//t[̃TCY`ĕ\
		this.setSize(300, 70);
		this.setVisible(true);
	}

	public double getNumber(){
		return number;
	}
}